var git = require( '../' ).raw,
    rimraf = require( '../vendor/rimraf' );

// Helper functions
var helper = {
  // Test if obj is a true function
  testFunction: function( test, obj, label ) {
    // The object reports itself as a function
    test( typeof obj, 'function', label +' reports as a function.' );
    // This ensures the repo is actually a derivative of the Function [[Class]]
    test( toString.call( obj ), '[object Function]', label +' [[Class]] is of type function.' );
  },
  // Test code and handle exception thrown 
  testException: function( test, fun, label ) {
    try {
      fun();
      test( false, label );
    }
    catch (ex) {
      test( true, label );
    }
  }
};

var repo = new git.Repo();

// Obj
exports.constructor = function( test ){
  test.expect( 3 );

  // Test for function
  helper.testFunction( test.equals, git.Object, 'GitObject' );

  // Ensure we get an instance of Obj
  test.ok( new git.Object() instanceof git.Object, 'Invocation returns an instance of GitObject' );

  test.done();
};
